package org.mercury_im.messenger.ui.login;

import android.app.AlertDialog;
import android.content.DialogInterface;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;

import androidx.appcompat.app.AppCompatActivity;

import org.mercury_im.messenger.MercuryImApplication;
import org.mercury_im.messenger.R;
import org.mercury_im.messenger.persistence.model.AccountModel;
import org.mercury_im.messenger.persistence.repository.AccountRepository;

import javax.inject.Inject;

import io.reactivex.schedulers.Schedulers;

public class AccountsActivity extends AppCompatActivity
        implements AccountsFragment.OnAccountListItemClickListener {

    @Inject
    AccountRepository accountRepository;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.content_accounts);
        MercuryImApplication.getApplication().getAppComponent().inject(this);

        AccountsFragment accountsFragment = (AccountsFragment) getSupportFragmentManager()
                .findFragmentById(R.id.fragment_accounts);
    }

    @Override
    public void onAccountListItemClick(AccountModel item) {
        View dialogView = LayoutInflater.from(this).inflate(R.layout.dialog_account_details, null);

        AlertDialog.Builder builder = new AlertDialog.Builder(this)
                .setView(dialogView)
                .setTitle(item.getJid())
                .setPositiveButton("Save", new DialogInterface.OnClickListener() {
                    @Override
                    public void onClick(DialogInterface dialogInterface, int i) {

                    }
                });
        builder.create().show();
    }

    @Override
    public void onAccountListItemLongClick(AccountModel item) {
        accountRepository.deleteAccount(item)
                .subscribeOn(Schedulers.io())
                .subscribe();
    }
}
