package org.mercury_im.messenger.ui.roster;

import android.content.Context;
import android.os.Bundle;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;

import androidx.fragment.app.Fragment;
import androidx.lifecycle.ViewModelProviders;
import androidx.recyclerview.widget.RecyclerView;

import org.mercury_im.messenger.R;

import java.util.ArrayList;

import static androidx.constraintlayout.widget.Constraints.TAG;

/**
 * A placeholder fragment containing a simple view.
 */
public class RosterFragment extends Fragment {

    private RosterViewModel rosterViewModel;

    private RosterRecyclerViewAdapter recyclerViewAdapter;

    RecyclerView recyclerView;

    public RosterFragment() {

    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        View view = inflater.inflate(R.layout.fragment_roster_entry_list, container, false);

        recyclerView = view.findViewById(R.id.roster_entry_list__recycler_view);
        recyclerViewAdapter = new RosterRecyclerViewAdapter(new ArrayList<>());
        recyclerView.setAdapter(recyclerViewAdapter);

        return view;
    }

    @Override
    public void onAttach(Context context) {
        super.onAttach(context);
        rosterViewModel = ViewModelProviders.of(getActivity()).get(RosterViewModel.class);
        observeViewModel(rosterViewModel);
    }

    private void observeViewModel(RosterViewModel viewModel) {
        viewModel.getRosterEntryList().observe(this, rosterEntries -> {
            if (rosterEntries == null) {
                Log.d(TAG, "Displaying null roster entries");
                return;
            }
            recyclerViewAdapter.setItems(rosterEntries);
            Log.d(TAG, "Displaying " + rosterEntries.size() + " roster entries");
        });
    }
}
