package org.mercury_im.messenger.persistence.room.dao;

import androidx.room.Delete;
import androidx.room.Insert;
import androidx.room.Update;

import io.reactivex.Completable;
import io.reactivex.Single;

public interface BaseDao<T> {

    @Insert
    Single<Long> insert(T entity);

    @Update
    Completable update(T entity);

    @Update
    Completable update(T[] entities);

    @Delete
    Completable delete(T entity);

    @Delete
    Completable delete(T[] entities);
}
