package org.mercury_im.messenger.persistence.room.dao;

import androidx.annotation.WorkerThread;
import androidx.room.Dao;
import androidx.room.Delete;
import androidx.room.Insert;
import androidx.room.Query;

import org.mercury_im.messenger.persistence.room.model.RoomEntityCapsModel;

import java.util.List;

import io.reactivex.Completable;
import io.reactivex.Single;

import static androidx.room.OnConflictStrategy.REPLACE;

@Dao
@WorkerThread
public interface EntityCapsDao {

    @Query("SELECT * FROM entity_caps WHERE pk_node_ver = :nodeVer")
    Single<RoomEntityCapsModel> getEntityCapsForNodeVer(String nodeVer);

    @Query("SELECT * FROM entity_caps")
    Single<List<RoomEntityCapsModel>> getAllEntityCaps();

    @Insert(onConflict = REPLACE)
    Completable insert(List<RoomEntityCapsModel> models);

    @Insert(onConflict = REPLACE)
    Completable insert(RoomEntityCapsModel model);

    @Delete
    Completable delete(List<RoomEntityCapsModel> models);

    @Delete
    Completable delete(RoomEntityCapsModel model);

    @Query("DELETE FROM entity_caps")
    Completable deleteAllEntityCaps();
}
