package org.mercury_im.messenger.persistence.model;


import org.jxmpp.jid.EntityBareJid;

import java.io.File;

/**
 * An {@link EntityModel} represents an XMPP user as seen by an account.
 * Its primary key should be composited of its {@link EntityBareJid} and the primary key of the
 * {@link AccountModel} which is communicating with the user.
 */
public interface EntityModel {

    long getId();

    void setId(long id);

    EntityBareJid getJid();

    void setJid(EntityBareJid jid);

    long getAccountId();

    void setAccountId(long accountId);

    File getAvatarFile();

    void setAvatarFile(File file);
}
