package org.mercury_im.messenger.persistence.repository;

import org.mercury_im.messenger.persistence.model.EntityCapsModel;

import java.util.List;

import io.reactivex.Completable;
import io.reactivex.Single;

public interface EntityCapsRepository<E extends EntityCapsModel> {

    E newEntityCapsModel(String nodeVer);

    Single<List<E>> getAllEntityCaps();

    Single<E> getEntityCapsForNodeVer(String nodeVer);

    Completable insertOrReplaceEntityCaps(List<E> entityCaps);

    Completable insertOrReplaceEntityCaps(E entityCaps);

    Completable deleteOrReplaceEntityCaps(List<E> entityCaps);

    Completable deleteOrReplaceEntityCaps(E entityCaps);

    Completable deleteAllEntityCaps();
}
